Inhalte

# Dienst SFDialogs.Dialog

The Dialog service contributes to the management of dialogs created with the Basic Dialog Editor or dialogs created on-the-fly. Each instance of the current class represents a single dialog box displayed to the user.

Der Dialog kann im modalen oder im nicht-modalen Modus angezeigt werden.

Im modalen Modus wird das Feld angezeigt und die Ausführung des Makroprozesses ausgesetzt, bis eine der Schaltflächen „OK“ oder „Abbrechen“ gedrückt wird. In der Zwischenzeit können auf der Box ausgeführte Benutzeraktionen bestimmte Aktionen auslösen.

Im nicht-modalen Modus „schwebt“ der Dialog auf dem Desktop des Benutzers und die Ausführung des Makroprozesses wird normal fortgesetzt. Der nicht-modale Dialog wird geschlossen, wenn er mit der Methode Terminate() beendet wird oder wenn die LibreOffice-Sitzung endet. Die Schaltfläche zum Schließen des Fensters ist in nicht-modalen Dialogen inaktiv.

Der Dialog verschwindet nach seiner expliziten Beendigung aus dem Speicher.

Der Dienst SFDialogs.Dialog ist eng mit dem Dienst SFDialogs.DialogControl verwandt.

## Dienstaufruf und Nutzung

Vor der Verwendung des Dienstes Dialog muss die Bibliothek ScriptForge geladen oder importiert werden:

• Grundlegende Makros erfordern das Laden der Bibliothek ScriptForge mit der folgenden Anweisung:
GlobalScope.BasicLibraries.loadLibrary("ScriptForge")
• Python-Skripte erfordern einen Import aus dem Modul scriptforge:
from scriptforge import CreateScriptService

The Dialog service is invoked through the CreateScriptService method. It requires three supplemental positional arguments to specify the dialog box to activate:

Container: "GlobalScope" für vorinstallierte Bibliotheken oder ein Fenstername wie vom Dienst ScriptForge.UI definiert. Der Standardwert leere Zeichenfolge "" steht für das aktuelle Dokument.

Library: Der Name einer im Container enthaltenen Bibliothek, bei der die Groß-/Kleinschreibung beachtet wird. Der Standardwert ist "Standard".

DialogName: Eine Zeichenfolge mit Berücksichtigung der Groß-/Kleinschreibung, die den Dialog bezeichnet.

Die folgenden Beispiele in Basic und Python zeigen den Dialog dlgConsole, der zur gemeinsam genutzten Bibliothek ScriptForge gehört:

          Dim oDlg As Object, lButton As Long
          Dim Container As String, Library As String, DialogName As String
          Set oDlg = CreateScriptService("SFDialogs.Dialog", "GlobalScope", "ScriptForge", "dlgConsole")
          ' … Steuerungsinitialisierung startet hier …
          lButton = oDlg.Execute()
          ' Standardmodus = Modal
          If lButton = oDlg.OKBUTTON Then
          ' … Prozesskontrollen und erledigen, was hier nötig ist
          End If
          oDlg.Terminate()

Oder mit Python:

        dlg = CreateScriptService('SFDialogs.Dialog', 'GlobalScope', 'ScriptForge', 'dlgConsole')
        # … Steuerungsinitialisierung startet hier …
        rc = dlg.Execute()
        # Standardmodus ist Modal
        if rc == dlg.OKBUTTON:
            # … Prozesskontrollen und erledigen, was hier nötig ist
        dlg.Terminate()

Verwenden Sie die Zeichenfolge "GlobalScope" als Argument container, wenn der Dialog entweder in Meine Makros und Dialoge oder in Anwendungsmakros und -dialoge gespeichert ist.

The dialog service offers methods that create new controls dynamically in an existing dialog predefined with the Dialog Editor. A dialog is initialized with controls in the Dialog Editor and new controls can be added at run-time before or after the dialog Execute() statement.

The Dialog service can equally be invoked - through the CreateScriptService method - when creating dialogs on-the-fly. It requires two supplemental positional arguments after the name of the ad-hoc service "NewDialog":

DialogName: A case-sensitive string designating the dialog.

Place: Window location of the dialog being either :

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

        Sub newDialog()
            Dim oDlg As Object
           oDlg = CreateScriptService("NewDialog", "myDialog1", Array(100,200, 40, 110))
           ' ...
        End Sub

Or using Python:

        def newDialog():
           dlg = CreateScriptService('NewDialog', 'myDialog1', (100,200, 40, 110))
           # ... Process controls and do what is needed

All properties and methods applicable to predefined dialogs are available for such new dialogs. In particular the series of CreateXXX() methods for the addition of new dialog controls.

## Abrufen der Instanz "Dialog", die ein Dialogereignis ausgelöst hat

Eine Instanz des Dienstes Dialog kann über den Dienst SFDialogs.DialogEvent abgerufen werden, sofern der Dialog mit dem Dienst Dialog initiiert wurde. Im Beispiel unten enthält oDlg die Instanz Dialog, die das Dialogereignis ausgelöst hat.

        Sub aDialogEventHander(ByRef poEvent As Object)
            Dim oDlg As Object
            Set oDlg = CreateScriptService("SFDialogs.DialogEvent", poEvent)
            ' ...
        End Sub

Oder mit Python:

        def control_event_handler(event: uno):
            dlg = CreateScriptService("SFDialogs.DialogEvent", event)
            # ...

Beachten Sie, dass in den vorherigen Beispielen das Präfix "SFDialogs." weggelassen werden kann, wenn es angebracht erscheint.

### Behandlung von Ausnahmen in Ereignishandlern

Beim Erstellen einer Ereignisbehandlungsroutine für Dialogereignisse empfiehlt es sich, Fehler innerhalb der Subroutine selbst zu behandeln. Angenommen, der unten stehende Ereignishandler wird aufgerufen, wenn die Maustaste im Dialogfenster gedrückt wird.

        Sub OnMouseButtonPressed(ByRef oEvent As Object)
        On Local Error GoTo Catch
            Dim oDialog As Object
            oDialog = CreateScriptService("DialogEvent", oEvent)
            ' Das Ereignis verarbeiten
            Exit Sub
        Catch:
            MsgBox SF_Exception.Description
            SF_Exception.Clear
        End Sub

Rufen Sie SF_Exception.Clear auf, wenn Sie nicht möchten, dass der Fehler nach Beendigung der Dialogausführung weitergegeben wird.

Verwenden Sie in Python native Blöcke try/except für die Ausnahmebehandlung, wie unten gezeigt:

        def on_mouse_button_pressed(event=None):
            try:
                dlg = CreateScriptService("DialogEvent", event)
                # Verarbeite das Ereignis
            except Exception as e:
                # Das Objekt "bas" ist eine Instanz des Dienstes Basic
                bas.MsgBox(str(e))

## Eigenschaften

Name | Schreibgeschützt | Typ | Beschreibung
--- | --- | --- | ---
OKBUTTON | Ja | Integer | Wert = 1. Die Schaltfläche "OK" wurde gedrückt.
CANCELBUTTON | Ja | Integer | Wert = 0. Die Schaltfläche "Abbrechen" wurde gedrückt.
Caption | Nein | String | Legt den Titel des Dialogs fest.
Height | Nein | Long | Legt die Höhe des Dialogs fest.
Modal | Ja | Boolean | Legt fest, ob der Dialog derzeit im modalen Modus ausgeführt wird.
Name | Ja | String | Der Name des Dialogs
Page | Nein | Integer | Der Dialog kann mehrere Seiten haben, die vom Benutzer Schritt für Schritt durchlaufen werden können. Die Eigenschaft "Page" des Objekts "Dialog" definiert, welche Seite des Dialogs aktiv ist.
Visible | Nein | Boolean | Legt fest, ob der Dialog auf dem Desktop sichtbar ist. Standardmäßig ist er nicht sichtbar, bis die Methode "Execute()" ausgeführt wird und danach sichtbar ist.
XDialogModel | Ja | UNO object | Das UNO-Objekt, welches das Dialogmodell darstellt. Siehe XControlModel und UnoControlDialogModel in der Programmierschnittstelle (API).
XDialogView | Ja | UNO object | Das UNO-Objekt, das die Dialogansicht darstellt. Siehe XControl und UnoControlDialog in der Dokumentation der Programmierschnittstelle (API) für detaillierte Informationen.
Width | Nein | Long | Legt die Breite des Dialogs fest.

## Ereigniseigenschaften

On… properties return a URI string with the reference to the script triggered by the event. On… properties can be set programmatically.
Read its specification in the scripting framework URI specification.

Name | Read/Write | Basic-IDE-Beschreibung
--- | --- | ---
OnFocusGained | Ja | Beim Erhalten des Fokus
OnFocusLost | Ja | Beim Verlust des Fokus
OnKeyPressed | Ja | Beim Tastendruck
OnKeyReleased | Ja | Beim Taste loslassen
OnMouseDragged | Ja | Bei Mausbewegung während Tastedruck
OnMouseEntered | Ja | Maus hinein
OnMouseExited | Ja | Maus heraus
OnMouseMoved | Ja | Mausbewegung
OnMousePressed | Ja | Mausklick
OnMouseReleased | Ja | Maustaste lösen

Assigning events via the Basic IDE and assigning events via macros are mutually exclusive.

Liste der Methoden im Dienst "Dialog"

Activate
Center
Controls
CloneControl
CreateButton
CreateCheckBox
CreateComboBox
CreateCurrencyField
CreateDateField
CreateFileControl
CreateFixedLine

CreateFixedText
CreateFormattedField
CreateGroupBox
CreateHyperlink
CreateImageControl
CreateListBox
CreateNumericField
CreatePatternField
CreateProgressBar
CreateRadioButton
CreateScrollBar

CreateTableControl
CreateTextField
CreateTimeField
CreateTreeControl
EndExecute
Execute
GetTextsFromL10N
Resize
OrderTabs
SetPageManager
Terminate

Dimensioning a dialog is done by using Map AppFont units. A dialog or control model also uses AppFont units. While their views use pixels.

## Activate

Setzt den Fokus auf die aktuelle Instanz von Dialog. Gib True zurück, wenn die Fokussierung erfolgreich war.

Diese Methode wird von einem Dialog- oder Steuerereignis aufgerufen oder wenn ein Dialog im nicht-modalen Modus angezeigt wird.

### Syntax:

svc.Activate(): bool

### Beispiel:

          Dim oDlg As Object
          Set oDlg = CreateScriptService(,, "myDialog")
          oDlg.Execute()
          ' ...
          oDlg.Activate()

Python- und LibreOffice Basic-Beispiele setzen beide voraus, dass der Dialog in der Bibliothek Standard des aktuellen Dokuments gespeichert ist.

         dlg = CreateScriptService(,,'myDialog')
         dlg.Execute()
         # ...
         dlg.Activate()

## Center

Zentriert den aktuellen Dialog in der Mitte eines übergeordneten Fensters. Ohne Argumente zentriert die Methode den Dialog in der Mitte des aktuellen Fensters.

Gibt bei Erfolg True zurück.

### Syntax:

svc.Center(opt Parent: obj): bool

### Parameter:

Parent: Ein optionales Objekt …

- ein Dialog "ScriptForge"

- ein Dokument (Calc, Base, …) "ScriptForge"

### Beispiel:

##### In Basic

         Sub TriggerEvent(oEvent As Object)
             Dim oDialog1 As Object, oDialog2 As Object, lExec As Long
             Set oDialog1 = CreateScriptService("DialogEvent", oEvent) ' Der Dialog, der das Ereignis verursacht hat
             Set oDialog2 = CreateScriptService("Dialog", …) ' Öffnet einen zweiten Dialog
             oDialog2.Center(oDialog1)
             lExec = oDialog2.Execute()
             Select Case lExec
                 ...
         End Sub

##### In Python

         def triggerEvent(event: uno):
           dlg1 = CreateScriptService('DialogEvent.Dialog', event) # Der Dialog, der das Ereignis verursacht hat
           dlg2 = CreateScriptService('Dialog', …)  # Öffnet einen zweiten Dialog
           dlg2.Center(dlg1)
           rc = dlg2.Execute()
           if rc is False:
             # ...

## CloneControl

Duplicate an existing control of any type in the actual dialog. The duplicated control is left unchanged and can be relocated.

### Syntax:

svc.CloneControl(SourceName: str, ControlName: str, Left: num, Top: num): svc

### Parameter:

SourceName: The name of the control to duplicate.

ControlName: A valid control name as a case-sensitive string. It must not exist yet.

Left, Top: The coordinates of the new control expressed in Map AppFont units.

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

          Set myButton2 = oDlg.CloneControl("Button1", "Button2", 30, 30)

##### In Python

         dlg = dlg.CloneControl('Button1', 'Button2', 30, 30)

## Controls

Rückgabe:

- die Liste der im Dialog enthaltenen Steuerelemente

- eine Klasseninstanz von DialogControl basierend auf ihrem Namen

### Syntax:

svc.Controls(): str[0..*]

svc.Controls(controlname: str): svc

### Parameter:

ControlName: Ein gültiger Steuerelementname als Zeichenfolge mit Beachtung der Groß-/Kleinschreibung. Wenn nicht vorhanden, wird die Liste der Steuerelementnamen als nullbasierte Matrix zurückgegeben.

### Beispiel:

          Dim myDialog As Object, myList As Variant, myControl As Object
          Set myDialog = CreateScriptService("SFDialogs.Dialog", , "Standard", "Dialog1")
          myList = myDialog.Controls()
          Set myControl = myDialog.Controls("myTextBox")

         dlg = CreateScriptService('SFDialogs.Dialog','', 'Standard', 'Dialog1')
         ctrls = dlg.Controls()
         ctrl = dlg.Controls('myTextBox')

## CreateButton

Create a new control of type Button in the current dialog.

### Syntax:

svc.CreateButton(ControlName: str, Place: any, Toggle: bool = False, Push: str = ""): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Toggle: when True a Toggle button is created. Default = False

Push: "OK", "CANCEL" or "" (default)

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myButton = oDlg.CreateButton("Button1", Array(20, 20, 60, 15))

##### In Python

         myButton = dlg.CreateButton('Button1', (20, 20, 60, 15))

## CreateCheckBox

Create a new control of type CheckBox in the current dialog.

### Syntax:

svc.CreateCheckBox(ControlName: str, Place: any, Multiline: bool = False): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

MultiLine: When True (default = False), the caption may be displayed on more than one line.

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myCheckBox = oDlg.CreateCheckBox("CheckBox1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myCheckBox = dlg.CreateCheckBox('CheckBox1', (20, 20, 60, 15), MultiLine = True)

## CreateComboBox

Create a new control of type ComboBox in the current dialog.

### Syntax:

svc.CreateComboBox(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = True, LineCount: num = 5): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

DropDown: When True (default), a drop down button is displayed

LineCount: Specifies the maximum line count displayed in the drop down (default = 5)

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myComboBox = oDlg.CreateComboBox("ComboBox1", Array(20, 20, 60, 15), Dropdown := True)

##### In Python

         myComboBox = dlg.CreateComboBox('ComboBox1', (20, 20, 60, 15), Dropdown = True)

## CreateCurrencyField

Create a new control of type CurrencyField in the current dialog.

### Syntax:

svc.CreateCurrencyField(ControlName: str, Place: any, Border ="3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = +1000000, Increment: num = 1, Accuracy: num = 2): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

SpinButton: when True (default = False), a spin button is present

MinValue: the smallest value that can be entered in the control. Default = -1000000

MaxValue: the largest value that can be entered in the control. Default = +1000000

Increment: the step when the spin button is pressed. Default = 1

Accuracy: specifies the decimal accuracy. Default = 2 decimal digits

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myCurrencyField = oDlg.CreateCurrencyField("CurrencyField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myCurrencyField = dlg.CreateCurrencyField('CurrencyField1', (20, 20, 60, 15), SpinButton = True)

## CreateDateField

Create a new control of type DateField in the current dialog.

### Syntax:

svc.CreateDateField(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = False, opt MinDate: datetime, opt MaxDate: datetime): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

DropDown: when True (default = False), a dropdown button is shown

MinDate: the smallest date that can be entered in the control. Default = 1900-01-01

MaxDate: the largest date that can be entered in the control. Default = 2200-12-31

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myDateField = oDlg.CreateDateField("DateField1", Array(20, 20, 60, 15), Dropdown := True)

##### In Python

         myDateField = dlg.CreateDateField('DateField1', (20, 20, 60, 15), Dropdown = True)

## CreateFileControl

Create a new control of type FileControl in the current dialog.

### Syntax:

svc.CreateFileControl(ControlName: str, Place: any, Border: str = "3D"): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myFileControl = oDlg.CreateFileControl("FileControl1", Array(20, 20, 60, 15))

##### In Python

         myFileControl = dlg.CreateFileControl('FileControl1', (20, 20, 60, 15))

## CreateFixedLine

Create a new control of type FixedLine in the current dialog.

### Syntax:

svc.CreateFixedLine(ControlName: str, Place: any, Orientation: str): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Orientation: "H[orizontal]" or "V[ertical]".

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myFixedLine = oDlg.CreateFixedLine("FixedLine1", Array(20, 20, 60, 15), Orientation := "vertical")

##### In Python

         myFixedLine = dlg.CreateFixedLine('FixedLine1', (20, 20, 60, 15), Orientation = 'vertical')

## CreateFixedText

Create a new control of type FixedText in the current dialog.

### Syntax:

svc.CreateFixedText(ControlName: str, Place: any, Border: str = "3D", MultiLine: bool = False, Align: str = "LEFT", VerticalAlign: str = "TOP"): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "NONE" (default) or "FLAT" or "3D"

Multiline: When True (default = False), the caption may be displayed on more than one line

Align: horizontal alignment, "LEFT" (default) or "CENTER" or "RIGHT"

VerticalAlign: vertical alignment, "TOP" (default) or "MIDDLE" or "BOTTOM"

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myFixedText = oDlg.CreateFixedText("FixedText1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myFixedText = dlg.CreateFixedText('FixedText1', (20, 20, 60, 15), MultiLine = True)

## CreateFormattedField

Create a new control of type FormattedField in the current dialog.

### Syntax:

svc.CreateFormattedField(ControlName: str, Place: any, Border: str = "3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = +1000000): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

SpinButton: when True (default = False), a spin button is present

MinValue: the smallest value that can be entered in the control. Default = -1000000

MaxValue: the largest value that can be entered in the control. Default = +1000000

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myFormattedField = oDlg.CreateFormattedField("FormattedField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myFormattedField = dlg.CreateFormattedField('FormattedField1', (20, 20, 60, 15), SpinButton = True)

## CreateGroupBox

Create a new control of type GroupBox in the current dialog.

### Syntax:

svc.CreateGroupBox(ControlName: str, Place: any): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myGroupBox = oDlg.CreateGroupBox("GroupBox1", Array(20, 20, 60, 15))

##### In Python

         myGroupBox = dlg.CreateGroupBox('GroupBox1', (20, 20, 60, 15))

## CreateHyperlink

Create a new control of type Hyperlink in the current dialog.

### Syntax:

svc.CreateHyperlink(ControlName: str, Place: any, Border: str = "NONE", MultiLine: bool = False, Align: str = "LEFT", VerticalAlign: str = "TOP"): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "NONE" (default) or "FLAT" or "3D"

MultiLine: When True (default = False), the caption may be displayed on more than one line

Align: horizontal alignment, "LEFT" (default) or "CENTER" or "RIGHT"

VerticalAlign: vertical alignment, "TOP" (default) or "MIDDLE" or "BOTTOM"

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myHyperlink = oDlg.CreateHyperlink("Hyperlink1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myHyperlink = dlg.CreateHyperlink('Hyperlink1', (20, 20, 60, 15), MultiLine = True)

## CreateImageControl

Create a new control of type ImageControl in the current dialog.

### Syntax:

svc.CreateImageControl(ControlName: str, Place: any, Border: str = "3D", Scale: str = "FITTOSIZE"): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

Scale: One of next values: "FITTOSIZE" (default), "KEEPRATIO" or "NO"

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myImageControl = oDlg.CreateImageControl("ImageControl1", Array(20, 20, 60, 15))

##### In Python

           myImageControl = dlg.CreateImageControl('ImageControl1", (20, 20, 60, 15))

## CreateListBox

Create a new control of type ListBox in the current dialog.

### Syntax:

svc.CreateListBox(ControlName: str, Place: any, Border: str = "3D", DropDown: bool = True, LineCount: num = 5, MultiSelect: bool = False): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

DropDown: When True (default), a drop down button is displayed

LineCount: Specifies the maximum line count displayed in the drop down (default = 5)

MultiSelect: When True, more than 1 entry may be selected. Default = False

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myListBox = oDlg.CreateListBox("ListBox1", Array(20, 20, 60, 15), Dropdown := True, MultiSelect := True)

##### In Python

         myListBox = dlg.CreateListBox('ListBox1', (20, 20, 60, 15), Dropdown = True, MultiSelect = True)

## CreateNumericField

Create a new control of type NumericField in the current dialog.

### Syntax:

svc.CreateNumericField(ControlName: str, Place: any, Border: str = "3D", SpinButton: bool = False, MinValue: num = -1000000, MaxValue: num = 1000000, Increment: num = 1, Accuracy: num = 2): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

SpinButton: when True (default = False), a spin button is present

MinValue: the smallest value that can be entered in the control. Default = -1000000

MaxValue: the largest value that can be entered in the control. Default = +1000000

Increment: the step when the spin button is pressed. Default = 1

Accuracy: specifies the decimal accuracy. Default = 2 decimal digits

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myNumericField = oDlg.CreateNumericField("NumericField1", Array(20, 20, 60, 15), SpinButton := True)

##### In Python

         myNumericField = dlg.CreateNumericField('NumericField1', (20, 20, 60, 15), SpinButton = True)

## CreatePatternField

Create a new control of type PatternField in the current dialog.

### Syntax:

svc.CreatePatternField(ControlName: str, Place: any, Border: str = "3D", EditMask: str, opt LiteralMax: str): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

EditMask: a character code that determines what the user may enter
Refer to Pattern_Field in the wiki for more information.

LiteralMask: contains the initial values that are displayed in the pattern field

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myPatternField = oDlg.CreatePatternField("PatternField1", Array(20, 20, 60, 15), EditMask := "NNLNNLLLLL", LiteralMask := "__.__.2002")

##### In Python

         myPatternField = dlg.CreatePatternField('PatternField1', (20, 20, 60, 15), EditMask = 'NNLNNLLLLL', LiteralMask = '__.__.2002')

## CreateProgressBar

Create a new control of type ProgressBar in the current dialog.

### Syntax:

svc.CreateProgressBar(ControlName: str, opt Place: any, Border: str = "3D", MinValue: num = 0, MaxValue: num = 100): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

MinValue: the smallest value that can be entered in the control. Default = 0

MaxValue: the largest value that can be entered in the control. Default = 100

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myProgressBar = oDlg.CreateProgressBar("ProgressBar1", Array(20, 20, 60, 15), MaxValue := 1000)

##### In Python

         myProgressBar = dlg.CreateProgressBar('ProgressBar1', (20, 20, 60, 15), MaxValue = 1000)

## CreateRadioButton

Create a new control of type RadioButton in the current dialog.

### Syntax:

svc.CreateRadioButton(ControlName: str, Place: any, MultiLine: bool = False): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

MultiLine: When True (default = False), the caption may be displayed on more than one line

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myRadioButton = oDlg.CreateRadioButton("RadioButton1", Array(20, 20, 60, 15), MultiLine := True)

##### In Python

         myRadioButton = dlg.CreateRadioButton('RadioButton1', (20, 20, 60, 15), MultiLine = True)

## CreateScrollBar

Create a new control of type ScrollBar in the current dialog.

### Syntax:

svc.CreateScrollBar(ControlName: str, Place, Orientation: str, Border: str = "3D", MinValue: num = 0, MaxValue: num = 100): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Orientation: H[orizontal] or V[ertical]

Border: "3D" (default) or "FLAT" or "NONE"

MinValue: the smallest value that can be entered in the control. Default = 0

MaxValue: the largest value that can be entered in the control. Default = 100

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myScrollBar = oDlg.CreateScrollBar("ScrollBar1", Array(20, 20, 60, 15), MaxValue := 1000)

##### In Python

         myScrollBar = dialog.CreateScrollBar('ScrollBar1', (20, 20, 60, 15), MaxValue = 1000)

## CreateTableControl

Create a new control of type TableControl in the current dialog.

### Syntax:

svc.CreateTableControl(ControlName: str, Place: any, Border: str = "3D", RowHeaders: bool = True, ColumnHeaders: bool = True, ScrollBars: str = "N", GridLines: bool = False): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

RowHeaders: when True (default), the row Headers are shown

ColumnHeaders: when True (default), the column Headers are shown

ScrollBars: H[orizontal] or V[ertical] or B[oth] or N[one] (default). Scrollbars appear dynamically when they are needed.

GridLines: when True (default = False) horizontal and vertical lines are painted between the grid cells

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myTableControl = oDlg.CreateTableControl("TableControl1", Array(20, 20, 60, 15), ScrollBars := "B")

##### In Python

         myTableControl = dlg.CreateTableControl('TableControl1', (20, 20, 60, 15), ScrollBars = 'B')

## CreateTextField

Create a new control of type TextField in the current dialog.

### Syntax:

svc.CreateTextField(ControlName: str, Place: any, Border: str = "3D", MultiLine: bool = False, MaximumLength: num = 0, PasswordCharacter: str = ""): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

MultiLine: When True (default = False), the caption may be displayed on more than one line

MaximumLength: the maximum character count (default = 0 meaning unlimited)

PasswordCharacter: a single character specifying the echo for a password text field (default = "")

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

    Set myTextField = oDlg.CreateTextField("TextField1", Array(20, 20, 120, 50), MultiLine := True)

##### In Python

         myTextField = dlg.CreateTextField('TextField1', (20, 20, 120, 50), MultiLine = True)

## CreateTimeField

Create a new control of type TimeField in the current dialog.

### Syntax:

svc.CreateTimeField(ControlName: str, Place: any, Border: str = "3D", MinTime: num = 0, MaxTime: num = 24): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

MinTime: the smallest time that can be entered in the control. Default = 0

MaxTime: the largest time that can be entered in the control. Default = 24h

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myTimeField = oDlg.CreateTimeField("TimeField1", Array(20, 20, 60, 15))

##### In Python

         myTimeField = dlog.CreateTimeField('TimeField1', (20, 20, 60, 15))

## CreateTreeControl

Create a new control of type TreeControl in the current dialog.

### Syntax:

svc.CreateTreeControl(ControlName: str, Place: any, Border = "3D"): svc

### Parameter:

ControlName: the name of the new control. It must not exist yet.

Place: either …

- a Basic Array or Python tuple with 4 elements: (X, Y, width, height)

- a com.sun.star.awt.Rectangle [X, Y, Width, Height] object

All elements are expressed in Map AppFont units.

Border: "3D" (default) or "FLAT" or "NONE"

### Rückgabewert:

An instance of SFDialogs.DialogControl service or Nothing.

### Beispiel:

##### In Basic

         Set myTreeControl = oDlg.CreateTreeControl("TreeControl1", Array(20, 20, 60, 15))

##### In Python

         myTreeControl = dlg.CreateTreeControl('TreeControl1', (20, 20, 60, 15))

## EndExecute

Beendet die Anzeige eines modalen Dialogs und gibt das Argument als Rückgabewert für die aktuell laufende Aktion Execute() zurück.

EndExecute() ist normalerweise in der Verarbeitung eines Makros enthalten, das durch ein Dialog- oder Steuerereignis ausgelöst wird.

### Syntax:

svc.EndExecute(returnvalue: int)

### Parameter:

returnvalue: Der Wert, der an die laufende Methode Execute() übergeben wird.

### Beispiel:

##### In Basic

          Sub OnEvent(poEvent As com.sun.star.lang.EventObject)
              Dim oDlg As Object
              Set oDlg = CreateScriptService("SFDialogs.DialogEvent", poEvent)
              oDlg.EndExecute(ReturnValue := 25)
          End Sub

##### In Python

         from com.sun.star.lang import EventObject
         def on_event(event: EventObject):
             dlg = CreateScriptService("SFDialogs.DialogEvent", event)
             dlg.EndExecute(25)

Obige Erwähnungen von com.sun.star.lang.EventObject sind optional. Solche Anmerkungen helfen bei der Identifizierung der LibreOffice-Programmierschnittstelle (API).

## Execute

Zeigt den Dialog an und wartet, wenn es modal ist, auf seine Beendigung durch den Benutzer. Der zurückgegebene Wert ist:

- 0: Schaltfläche Abbrechen gedrückt

- 1: Schaltfläche OK gedrückt

- Andernfalls wurde der Dialog mit einer Anweisung EndExecute() beendet, die von einem Dialog- oder Steuerereignis ausgegeben wurde

Bei nicht-modalen Dialogen gibt die Methode immer 0 zurück und die Ausführung des Makros wird fortgesetzt.

### Syntax:

svc.Execute(modal: bool = True): int

### Parameter:

modal: False bei nicht-modalem Dialog. Standard = True.

### Beispiel:

In diesem einfachen Beispiel wird der Dialog myDialog in der Bibliothek Standard des aktuellen Dokuments gespeichert.

          Dim oDlg As Object, lReturn As Long
          Set oDlg = CreateScriptService("SFDialogs.Dialog", , , "myDialog")
          lReturn = oDlg.Execute(Modal := False)
          Select Case lReturn
              ' ...
          End Select

Dieser Python-Code zeigt den modalen Dialog DlgConvert aus der gemeinsamen Basisbibliothek Euro an.

         dlg = CreateScriptService("SFDialogs.Dialog", 'GlobalScope', 'Euro', "DlgConvert")
         rc = dlg.Execute()
         if rc == dlg.CANCELBUTTON:
             # ...

## GetTextsFromL10N

Ersetzt alle festen Textzeichenfolgen in einem Dialog durch ihre übersetzten Versionen basierend auf einer Dienstinstanz L10N. Diese Methode übersetzt die folgenden Zeichenfolgen:

- Der Titel des Dialogs.

- Die Beschriftung der folgenden Steuerelementtypen: Schaltfläche, Markierfeld, Geschützte Linie, Beschriftungsfeld, Gruppenfeld und Optionsfeld.

- Statische Zeichenfolgen in Listenfeldern und Kombinationsfeldern.

- Der Hilfetext, der angezeigt wird, wenn die Maus über das Steuerelement bewegt wird.

Die Methode gibt bei Erfolg True zurück.

Verwenden Sie zum Erstellen einer Liste übersetzbarer Zeichenfolgen in einem Dialog die Methode AddTextsFromDialog des Dienstes "L10N".

### Syntax:

svc.GetTextsFromL10N(l10n: svc): bool

### Parameter:

l10n: Eine Dienstinstanz L10N, von der übersetzte Zeichenfolgen abgerufen werden.

### Beispiel:

Das folgende Beispiel lädt übersetzte Zeichenfolgen und wendet sie auf den Dialog "MyDialog" an.

##### In Basic

         oDlg = CreateScriptService("Dialog", "GlobalScope", "Standard", "MyDialog")
         myPO = CreateScriptService("L10N", "/home/user/po_files/")
         oDlg.GetTextsFromL10N(myPO)
         oDlg.Execute()

##### In Python

         dlg = CreateScriptService("Dialog", "GlobalScope", "Standard", "MyDialog")
         myPO = CreateScriptService("L10N", "/home/user/po_files/")
         dlg.GetTextsFromL10N(myPO)
         dlg.Execute()

Lesen Sie die Hilfeseite zum Dienst L10N, um mehr darüber zu erfahren, wie PO- und POT-Dateien gehandhabt werden.

## OrderTabs

Set the tabulation index of a series of controls. The sequence of controls are given as an array of control names from the first to the last.

Controls with an index >= 1 are not accessible with the TAB key if:
- they are omitted from the given list
- their type is FixedLine, GroupBox or ProgressBar
- they are disabled

### Syntax:

svc.TabsList(TabsList: num, Start: num = 1, Increment: num = 1): bool

### Parameter:

TabsList: an array of valid control names in the order of tabulation

Start: the tab index to be assigned to the 1st control in the list. Default = 1

Increment: the difference between 2 successive tab indexes. Default = 1

### Rückgabewert:

True when successful.

### Beispiel:

##### In Basic

         oDlg.OrderTabs(Array("myListBox", "myTextField", "myNumericField"), Start := 10)

##### In Python

         dlg.OrderTabs(('myListBox', 'myTextField', 'myNumericField'), Start = 10)

## Resize

Moves the topleft corner of a dialog to new coordinates and/or modify its dimensions. All distances are expressed in AppFont units. Without arguments, the method resets the initial dimensions. Return True if the resize was successful.

### Syntax:

svc.Resize(opt Left: num, opt Top: num, opt Width: num, opt Height: num): bool

### Parameter:

Left: der horizontale Abstand von der oberen linken Ecke

Top: Der vertikale Abstand von der oberen linken Ecke

Width: die Breite des Rechtecks, das den Dialog enthält

Height: die Höhe des Rechtecks, das den Dialog enthält

Missing arguments are left unchanged

### Beispiel:

##### In Basic

         oDlg.Resize(1000, 2000, Height := 6000) ' Width is not changed

##### In Python

         dlg.Resize(1000, 2000, Height = 6000)  # Width is not changed

## SetPageManager

Definiert, welche Steuerelemente in einem Dialog für das Wechseln von Seiten verantwortlich sind, wodurch die Verwaltung der Eigenschaft Page eines Dialogs und seiner Steuerelemente vereinfacht wird.

Dialoge können mehrere Seiten haben und die aktuell sichtbare Seite wird durch die Dialogeigenschaft Page definiert. Wenn die Eigenschaft Page unverändert gelassen wird, ist die standardmäßig sichtbare Seite gleich 0 (Null), was bedeutet, dass keine bestimmte Seite definiert ist und alle sichtbaren Steuerelemente angezeigt werden, unabhängig von dem Wert, der in ihrer eigenen Eigenschaft Page gesetzt ist.

Wenn die Eigenschaft Page eines Dialogs auf einen anderen Wert als 1, 2, 3 und so weiter geändert wird, dann werden nur die Steuerelemente angezeigt, deren Eigenschaft Page mit der aktuellen Dialogseite übereinstimmen.

Durch die Verwendung der Methode SetPageManager ist es möglich, vier Arten von Seitenmanagern zu definieren:

- Listenfeld oder Kombinationsfeld: Es entspricht jeder Eintrag in dem Listen- oder Kombinationsfeld einer Seite. Das erste Element bezieht sich auf Seite 1, das zweite Element bezieht sich auf Seite 2 und so weiter.

- Gruppe von Optionsfeldern: definiert eine Gruppe von Optionsfeldern, die steuern, welche Seite sichtbar ist.

- Schaltflächenfolge: definiert eine Reihe von Schaltflächen, von denen jede einer Dialogseite entspricht. Dies kann verwendet werden, um eine Oberfläche mit Registern zu emulieren, indem Schaltflächen nebeneinander im Dialog platziert werden.

- Schaltflächen Vorherige/Nächste: definiert, welche Schaltflächen im Dialog verwendet werden, um zur vorherigen/nächsten Seite im Dialog zu navigieren.

Es ist möglich, mehr als einen Seitenverwaltungsmechanismus gleichzeitig zu verwenden.

Diese Methode sollte nur einmal aufgerufen werden, bevor die Methode Execute aufgerufen wird. Nachfolgende Aufrufe werden ignoriert.

Bei Erfolg gibt diese Methode True zurück.

### Syntax:

svc.SetPageManager(pilotcontrols: str = "", tabcontrols: str = "", wizardcontrols: str = "", opt lastpage: int): bool

### Parameter:

pilotcontrols: eine durch Kommas getrennte Liste von Steuerelementennamen ListBox, ComboBox oder RadioButton, die als Seitenmanager verwendet werden. Legen Sie für Steuerelemente "RadioButton" den Namen des ersten zu verwendenden Steuerelements in der Gruppe fest.

Tabcontrols: eine durch Kommas getrennte Liste von Schaltflächennamen, die als Seitenmanager verwendet werden. Die Reihenfolge, in der sie in diesem Argument angegeben werden, entspricht der Seitenzahl, der sie zugeordnet sind.

wizardcontrols: eine durch Kommas getrennte Liste mit den Namen von zwei Schaltflächen, die als Schaltflächen Zurück/Weiter verwendet werden.

lastpage: die Nummer der letzten verfügbaren Seite. Es wird empfohlen, diesen Wert festzulegen, wenn Sie den Manager für vorherige/nächste Seite verwenden.

### Beispiel:

Stellen Sie sich einen Dialog mit drei Seiten vor. Der Dialog hat ein Steuerelement ListBox namens "aPageList", das verwendet wird, um die sichtbare Seite zu steuern. Zusätzlich gibt es zwei Schaltflächen mit den Namen "btnPrevious" und "btnNext", die als Schaltflächen Zurück/Weiter im Dialog verwendet werden.

##### In Basic

        oDlg.SetPageManager(PilotControls := "aPageList", _
                               WizardControls := "btnPrevious,btnNext", _
                               LastPage := 3)
        oDlg.Execute()

##### In Python

        dlg.SetPageManager(pilotcontrols="aPageList",
                           wizardcontrols="btnPrevious,btnNext",
                           lastpage=3)
        dlg.Execute()

## Terminate

Beendet den Dienst Dialog für die aktuelle Instanz. Gibt True zurück, wenn die Beendigung erfolgreich war.

### Syntax:

svc.Terminate(): bool

### Beispiel:

Die folgenden Basic- und Python-Beispiele öffnen die nicht-modalen Dialoge DlgConsole und dlgTrace. Sie werden jeweils in gemeinsam genutzten Bibliotheken von ScriptForge und Access2Base gespeichert. Schaltflächen zum Schließen von Dialogen sind deaktiviert und eine explizite Beendigung wird am Ende eines laufenden Prozesses durchgeführt.

In diesem Beispiel ersetzt eine Schaltfläche in DlgConsole das gesperrte Schließen des Fensters:

##### In Basic

         oDlg = CreateScriptService("SFDialogs.Dialog","GlobalScope","ScriptForge","DlgConsole")
         oDlg.Execute(modal:=False)
         Wait 5000
         oDlg.Terminate()

##### In Python

         from time import sleep
         dlg = CreateScriptService('SFDialogs.Dialog',"GlobalScope",'Access2Base',"dlgTrace")
         dlg.Execute(modal=False)
         sleep 5
         dlg.Terminate()

Alle ScriptForge Basic-Routinen oder Bezeichner, denen ein Unterstrich "_" vorangestellt ist, sind für den internen Gebrauch reserviert. Sie sind nicht für die Verwendung in Basic-Makros oder Python-Skripten vorgesehen.

Verwandte Themen

Dienst SFDialogs.DialogControl

Dienst ScriptForge.UI